package engine;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import javax.microedition.lcdui.*;

/**
 * @author DDDEN!SSS
 */
public class Figure { //класс содержащий стандартную 3D модель
    public Vertex[] vertexs; //вершинывершины
    public Element3D[] elements; // 3D элементы
    
    
    
    
    public Figure(byte[] b) {
        Creator.create(b, this);
    }
    
    
    
    public void setMatrix(Matrix m) { // поворачиваем вершины
        for (int i = 0; i < vertexs.length; i++) {
            vertexs[i].setMatrix(m);
        }
        for(int i=0; i<elements.length; i++) {
            elements[i].average();
        }
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    private static class Creator {
        private static final String vertexStr = "Vertex(";
        private static final String polygonStr = "Polygon(";
        private static final String lineStr = "Line(";
        
        
        public static void create(byte[] b, Figure f) {
            String model = new String(b);
            loadVertex(model, f);
            loadelEments(model, f);
        }
        
        private static void loadVertex(String m, Figure f) { //загружаем вершины
            int v1 = m.indexOf(vertexStr, 0);
            int v2 = m.indexOf(")", v1);
            String vertex = m.substring(v1+vertexStr.length(), v2);
            
            f.vertexs = new Vertex[r(vertex, ";")];
            int i1 = 0;
            int i2 = -1;
            for(int i=0; i<f.vertexs.length; i++) {
                i1 = vertex.indexOf(';', i2+1);
                String v = vertex.substring(i2+1, i1);
                f.vertexs[i] = new Vertex(v);
                i2 = i1;
            }
        }
        
        private static void loadelEments(String m, Figure f) { //загружаем 3Д елементы
            int p1 = m.indexOf(polygonStr, 0);
            int p2 = m.indexOf(")", p1);
            String polygon = m.substring(p1+polygonStr.length(), p2); //строка с полигонами
            
            int l1 = m.indexOf(lineStr, 0);
            int l2 = m.indexOf(")", l1);
            String line = m.substring(l1+lineStr.length(), l2); //строка с линиями
            
            int polygons = r(polygon, ";"); //сколько полигонов
            int lines = r(line, ";"); //сколько линий
            f.elements = new Element3D[polygons + lines];
            
            int i1 = 0;
            int i2 = -1;
            for(int i=0; i<polygons; i++) { //загружаем полигоны
                i1 = polygon.indexOf(';', i2+1);
                String p = polygon.substring(i2+1, i1);
                f.elements[i] = new Polygon(p, f.vertexs);
                i2 = i1;
            }
            i1 = 0;
            i2 = -1;
            for(int i=0; i<lines; i++) { //загружаем линии
                i1 = line.indexOf(';', i2+1);
                String l = line.substring(i2+1, i1);
                f.elements[i+polygons] = new Line(l, f.vertexs);
                i2 = i1;
            }
        }
        
        
        
        private static int r(String i, String r) { //сколько символов r в строке i
            int rr=0;
            int i1 = 0;
            int i2 = -1;
            while(true) {
                i1 = i.indexOf(r, i2 + 1);
                if(i1==-1) {
                    break;
                }
                rr++;
                i2 = i1;
            }
            return rr;
        }
        
        
    }
    
    
    
    
    
    
    
    
    
    
}
